#define MAIN_CALLING
#include "wmwfu.h"
#undef MAIN_CALLING 

/**************************************************************/
//Read configuration file (/etc/wmwfu/host_service.conf)
int readConfigfile(char param_conf[])
{

FILE *conf;
char buff[MAXLINHA],
     *ptr;
int  num_linha=0;

	
	//Open configuration file (/etc/wmwfu/host_service.conf)
    if((conf=fopen(param_conf,"r"))==NULL)
    {
    	printf("Erro: Faleid to open configuration file \"%s\".\n",param_conf);
    	return -1;
    }
	
	//Setting variables that store informations of configuration file NOT FOUND
	strcpy(strmachine.host,"NOT FOUND");                  
	strcpy(strmachine.ip,"NOT FOUND");                    
	strcpy(strmachine.service,"NOT FOUND");               
	strcpy(strmachine.porta,"NOT FOUND");                 
	strcpy(strmachine.email,"NOT FOUND");                 
	strcpy(strmachine.envsounds,"NOT FOUND");             
	strcpy(strmachine.audio,"NOT FOUND");                 
	strcpy(strmachine.monitor,"NOT FOUND");               
		
	//Read each line of configuration file
	while(fgets(buff,MAXLINHA,conf))
	{
		//Ignore comments
		if((strchr(buff,'#'))!=NULL)
			continue;
			
		switch(num_linha)
		{
			//[HOST]
			case(0):
				if((ptr=strstr(buff,"[HOST]"))==NULL)
				{
					printf("TAG [HOST] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
					
				break;
				
			//Get value of tag [HOST]
			case(1):
				ptr=buff;
				strcpy(strmachine.host,ptr);
				strmachine.host[strlen(ptr)-1]='\0';
				if(!strlen(strmachine.host))
				{
					printf("Value of tag HOST not exist.\n");
					return -1;
				}
				else
					num_linha++;
#ifdef _DEBUG					
printf("HOST=%s\n",strmachine.host);
#endif
				break;
			
			//[IP]
			case(2):
				if((ptr=strstr(buff,"[IP]"))==NULL)
				{
					printf("TAG [IP] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
					
				break;
				
			//Get value of tag [IP]
			case(3):
				ptr=buff;
				strcpy(strmachine.ip,ptr);
				strmachine.ip[strlen(ptr)-1]='\0';
				if(!strlen(strmachine.ip))
				{
					printf("Value of tag IP not exist.\n");
					return -1;
				}
				else
					num_linha++;

#ifdef _DEBUG
printf("IP=%s\n",strmachine.ip);
#endif
				break;


			//[SERVICE]
			case(4):
				if((ptr=strstr(buff,"[SERVICE]"))==NULL)
				{
					printf("TAG [SERVICE] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
					
				break;
				
			//Get value of tag [SERVICE]
			case(5):
				ptr=buff;
				strcpy(strmachine.service,ptr);
				strmachine.service[strlen(ptr)-1]='\0';
				if(!strlen(strmachine.service))
				{
					printf("Value of tag SERVICE not exist.\n");
					return -1;
				}
				else
					num_linha++;

#ifdef _DEBUG
printf("SERVICE=%s\n",strmachine.service);
#endif
				break;

			//[PORTA]
			case(6):
				if((ptr=strstr(buff,"[PORTA]"))==NULL)
				{
					printf("TAG [PORTA] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;					
					
				break;
				
			//Get value of tag [PORTA]
			case(7):
				ptr=buff;
				strcpy(strmachine.porta,ptr);
				strmachine.porta[strlen(ptr)-1]='\0';
				if(!strlen(strmachine.porta))
				{
					printf("Value of tag PORTA not exist.\n");
					return -1;
				}
				
				num_linha++;

#ifdef _DEBUG
printf("PORTA=%s\n",strmachine.porta);
#endif
				break;


			//[EMAIL]
			case(8):
				if((ptr=strstr(buff,"[EMAIL]"))==NULL)
				{
					printf("TAG [EMAIL] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
										
				break;
				
			//Get value of tag [EMAIL]
			case(9):
				ptr=buff;
				strcpy(strmachine.email,ptr);
				strmachine.email[strlen(ptr)-1]='\0';
				if(!strlen(strmachine.email))
				{
					printf("Value of tag EMAIL not exist.\n");
					return -1;
				}
				else
					num_linha++;
					
#ifdef _DEBUG
printf("EMAIL=%s\n",strmachine.email);
#endif
				break;

			//[ENVSOUNDS]
			case(10):
				if((ptr=strstr(buff,"[ENVSOUNDS]"))==NULL)
				{
					printf("TAG [ENVSOUNDS] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
					
				break;
				
			//Get value of tag [ENVSOUNDS]
			case(11):
				ptr=buff;
				strcpy(strmachine.envsounds,ptr);
				strmachine.envsounds[strlen(ptr)]='\0';
				if(!strlen(strmachine.envsounds))
				{
					printf("Value of tag ENVSOUNDS not exist.\n");
					return -1;
				}
				else
					num_linha++;
					
#ifdef _DEBUG
printf("ENVSOUNDS=%s\n",strmachine.envsounds);
#endif
				break;


			//[AUDIO]
			case(12):
				if((ptr=strstr(buff,"[AUDIO]"))==NULL)
				{
					printf("TAG [AUDIO] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
					
				break;
				
			//Get value of tag [AUDIO]
			case(13):
				ptr=buff;
				strcpy(strmachine.audio,ptr);
				strmachine.audio[strlen(ptr)-1]='\0';
				if(!strlen(strmachine.audio))
				{
					printf("Value of tag AUDIO not exist.\n");
					return -1;
				}
				else
					num_linha++;
					
#ifdef _DEBUG
printf("AUDIO=%s\n",strmachine.audio);
#endif
				break;


			//[MONITOR]
			case(14):
				if((ptr=strstr(buff,"[MONITOR]"))==NULL)
				{
					printf("TAG [MONITOR] is not found on configuration file.\n");
					return -1;
				}
				else
					num_linha++;
					
				break;
				
			//Get value of tag [MONITOR]
			case(15):
				ptr=buff;
    			strcpy(strmachine.monitor,ptr);
				strmachine.monitor[strlen(ptr)]='\0';
				if(!strlen(strmachine.monitor))
				{
					printf("Value of tag MONITOR not exist.\n");
					return -1;
				}
				else
					num_linha++;
					
#ifdef _DEBUG
printf("MONITOR=%s\n",strmachine.monitor);
#endif

				break;
			
			default:
				break;
		}		
	}
	return 0;

}

/**************************************************************/
//Check the remote host to service choosed 
int test_service()
{

FILE *fptr;
char *ptr;
char comando[256],
     buff[MAXLINHA];
int flgTestOK=-1;


	//Service PING
	if(!strcmp((char *)strmachine.service,"ping"))
	{
		sprintf(comando,"%s%s",PING,strmachine.ip);
#ifdef _DEBUG
printf("COMANDO=%s\n",comando);
#endif

		RedrawWindow ();
		
		if((fptr=popen(comando,"r"))==NULL)
        {
	        printf("Error on output of command \"%s\"\n.", comando);
        }
		
		RedrawWindow ();
		
	    while(fgets(buff,MAXLINHA,fptr))
	    {
	    	if((ptr=strstr(buff,"1 packets received"))!=NULL)
	    		flgTestOK=0;
	    }
        fclose(fptr);
  
  	  RedrawWindow ();
  	        
        //if Return 0 because service is OK.
        return flgTestOK;
	}
	
	printf("Service \"%s\" not existe. Create configuration file running script wmwfu-setup, OK?\n",strmachine.service);
	exit (-1);
}

/**************************************************************/
int playerSound(char arqsom[])
{
char comando[256];

	if(!strncmp((char *)arqsom,"NOT FOUND",9))
		return -1;
	
	sprintf(comando,"%s%s &",SOUND,arqsom);

#ifdef _DEBUG
printf("PLAYER SOUND=%s\n",comando);
#endif

	return (system(comando)?1:0);

}

/**************************************************************/

int goMail(void)
{
char comando[256];


	if((!strcmp((char *)strmachine.email,"No"))||
	  (!strcmp((char *)strmachine.email,"NO"))||
	  (!strcmp((char *)strmachine.email,"no")))
	{
		return -1;
	}
		
	sprintf(comando,"echo \""
                	"To: %s\n"
                	"Reply-to: wmwfu@uol.com.br\n"
                	"From: wmwfu@uol.com.br\n"
                	"Subject: wmwfu - Problem host: %s\n"
                	"\n\n"
                	"IP: %s\n"
                	"SERVICE: %s\n"
                	"Status: PROBLEM\n"
                	"\n\n\" | sendmail -f wmwfu@uol.com.br -t %s",
                    strmachine.email,
 				   strmachine.host,
 				   strmachine.ip,
 				   strmachine.service,
 				   strmachine.email);
 							   
#ifdef _DEBUG		
printf("GO MAIL=%s\n",comando);
#endif

	return (system(comando)?1:0);							   
 		
}

/**************************************************************/

int writeTitle(void)
{
//Tabela ASCII (0-9 = 48-57) e (A-Z = 65-90) e (a-z = 97-122) 
int idx=0,
    indexArr=0,
    extraValue=0,
    flgPrintChar=0,
    destX=3;
int destY=3;
	
	for(idx=0;(idx < strlen(strmachine.host) && idx < 11);idx++)
	{

#ifdef _DEBUG
printf("CHAR[%i]=%c --->id=%d\n",idx,strmachine.host[idx],strmachine.host[idx]);
#endif

		for(indexArr=0;(indexArr < 38);indexArr++)
		{
		
			if(strmachine.host[idx] >= 97 && strmachine.host[idx] <= 122)
			{
				extraValue=32;				
			}
			else
				extraValue=0;			
			
			
			if((chrdockapp[indexArr].i + extraValue) == strmachine.host[idx])
			{

#ifdef _DEBUG
printf("I=%i,X=%i,Y=%i,W=%i,H=%i\n",chrdockapp[indexArr].i,
									chrdockapp[indexArr].x,
									chrdockapp[indexArr].y,
									chrdockapp[indexArr].w,
									chrdockapp[indexArr].h);
#endif


				XCopyArea(display, 
						  wmgen.pixmap, 
						  wmgen.pixmap, 
						  NormalGC, 
						  chrdockapp[indexArr].x,  
						  chrdockapp[indexArr].y, 
						  chrdockapp[indexArr].w, 
						  chrdockapp[indexArr].h, 
						  destX, 
						  destY);
				
				destX+=5;		  
				flgPrintChar++;
				break;
			}
		}

		if(!flgPrintChar)
		{
			XCopyArea(display, 
					  wmgen.pixmap, 
					  wmgen.pixmap, 
					  NormalGC, 
					  chrdockapp[indexArr].x,  
					  chrdockapp[indexArr].y, 
					  chrdockapp[indexArr].w, 
					  chrdockapp[indexArr].h, 
					  destX=+5, 
					  destY);
		}
		
		flgPrintChar=0;
		
	}
	
	return 0;
}

/**************************************************************/

int main (int argc, char *argv[]) {
  XEvent Event;
  char wmwfu_mask_bits[64*64];
  int wmwfu_mask_width = 64;
  int wmwfu_mask_height = 64;
  struct stat statinfo;
  char param_conf[256],
       pathconffile[256],
       pathenvsounds[256];
  int i=0,
      flgMonitor=1,
      flgEmail=0;
  long last_time=0,
       now_time=0;


  //Get parameters of command line
  while((i = getopt(argc,argv,"c:v")) != EOF)
  {
   	switch(i)
       {
       	case 'c': //path of configuration file.
			   strncpy(param_conf,optarg,255);
			   param_conf[255]='\0';		   
               break;
 
           case 'v': // version
               printf("wmwfu version 0.23 114(release)\n");
               return(0);
               break;
 
           default: //help
               printf("Usage:wmwfu [-c <conf file> -v{show version}]\n");
               return 0;
               break;
        }
 
	}

	//Error
    if(!strlen(param_conf))
    {
    	printf("Usage:wmwfu [-c <conf file> -v{show version}]\n");
    	return -1;
    }

#ifdef _DEBUG
printf("PARAMETRO=%s\n",param_conf);
#endif

  createXBMfromXPM (wmwfu_mask_bits, wmwfu_master_xpm, wmwfu_mask_width, wmwfu_mask_height);
  openXwindow (argc,argv,wmwfu_master_xpm,wmwfu_mask_bits,wmwfu_mask_width,wmwfu_mask_height);
  RedrawWindow ();
  
   //Add the area from event handle
   AddMouseRegion(1, 4, 15, 59, 59);  //Painel de status
  
   strcat(pathconffile,PATHCONFIGFILE);
   strcat(pathconffile,param_conf);

#ifdef _DEBUG   
printf("PATH_CONF_FILE=%s\n",pathconffile);
#endif

   //Check if configuration file exist
   if(stat(pathconffile,&statinfo))
   {
   	printf("Configuration file not found.\n");
   	return -1;
   }   
   RedrawWindow ();
 
	//Read configuration file
	if(readConfigfile((char *)&pathconffile))
		return -1;


	//Check tag [MONITOR] is equal "NO"
	if((!strncmp((char *)strmachine.monitor,"no",2)) || 
	  (!strncmp((char *)strmachine.monitor,"NO",2)) ||
	  (!strncmp((char *)strmachine.monitor,"No",2)))
	{
				XCopyArea(display, wmgen.pixmap, wmgen.pixmap, NormalGC, 187,  13, (246-187), (61-13), 2, 13);
				flgMonitor=0;  //0=Nao monitorar, ou seja, o programa vai ficar dormindo.
				RedrawWindow ();
	}

	//Sound start 
	if((!strncmp((char *)strmachine.envsounds,"yes",3)) || 
	  (!strncmp((char *)strmachine.envsounds,"YES",3)) ||
	  (!strncmp((char *)strmachine.envsounds,"Yes",3)))
	{
		
		sprintf(pathenvsounds,"%skbackgammon-lost.wav",PATHENVSOUNDS);
			
		if(playerSound(pathenvsounds))
		{
			printf("This sound cannot be played.\n");
		}	
	}

	//Get value of tag [HOST] and write title
	if(writeTitle())
	{
		printf("Error to write title.\n");
	}
		
	//Main while
	while (1)
	{
		RedrawWindow ();
		//Local time in seconds
		now_time = time(NULL);
		
		//Delay is 10 seconds
		if(((now_time - last_time)>DELAY) && (flgMonitor))
		{
			if(test_service())
			{
				//Picture of problem (atomic)
				XCopyArea(display, wmgen.pixmap, wmgen.pixmap, NormalGC, 126,  13, (186-126), (62-13), 2, 13);
				
				
				if((strncmp((char *)strmachine.audio,"no",3)) ||
				  (strncmp((char *)strmachine.audio,"NO",3)) ||
				  (strncmp((char *)strmachine.audio,"No",3)))
				{
					if(playerSound(strmachine.audio))
					{
						printf("This sound cannot be played.\n");
					}
				}
				
				if(!flgEmail){
					if(goMail())
					{
						printf("The local sendmail failed.\n");
					}
					flgEmail++; //Send mail only one time.
				}
				
			}
			else
			{
				//Picture without problem (penguin)
				XCopyArea(display, wmgen.pixmap, wmgen.pixmap, NormalGC, 65,  13, (125-65), (62-13), 2, 13);
				RedrawWindow ();
				flgEmail=0; //Setting variable of send mail
			}

			last_time = now_time;  //restart delay
		}

		//Redraw dock application and handle envent
		RedrawWindow ();
		while (XPending (display)) 
		{
			XNextEvent (display, &Event);
			switch (Event.type) 
			{
				case Expose:
					RedrawWindow ();
					break;
				case DestroyNotify:
					XCloseDisplay (display);
					exit (0);
					break;
				case ButtonPress:		
					//One day this will does anythink! HAHAHAHA!			
					break;				
				case ButtonRelease:
					break;				

				default:
					break;
			}
		}
    	usleep (USLEEP);
	}
	RedrawWindow ();
  return 0;
}
