#ifdef MAIN_CALLING
        #define GLOBAL
#else
        #define GLOBAL extern
#endif 

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <X11/xpm.h>
#include "../wmgeneral/wmgeneral.h"
#include "../xpm/wmwfu_master.xpm"



//Libera o processador 
#define USLEEP 20000 /* 2ms */
//path of configuration file,
#define PATHCONFIGFILE "/etc/wmwfu/"
//size buffer
#define MAXLINHA 1024
//Delay in seconds
#define DELAY 10
//Command line ping
#define PING "ping -c 1 "
//Command line sounds
#define SOUND "play "
//Path of environment sounds
#define PATHENVSOUNDS "/etc/wmwfu/envsounds/"
//Buffer de socket
#define BUFFERMAXLEN 10240
//ports HTTP e HTTPS(Coming Soon!!!)
#define HTTP_PORT 80
#define HTTPS_PORT 443


GC NormalGC;
//0123456789
int pos_num[] = {0,5,8,13,18,23,28,33,38,43,48}; 
//ABCDEFGHIJKLMNOPQRSTUVWXYZ
int pos_letra[] = {0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100,105,110,115,120,125,130};
//-:/.=espao 
int pos_outros[] = {0,3,6,10,12,15,19};
//cabecalho http
const char http_request[]= 
"GET / HTTP/1.0\r\n
Connection: Keep-Alive\r\n
User-Agent: TOME/1.00 (quase Intel)\r\n
Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png\r\n
Accept-Encoding: gzip\r\n
Accept-Language: en\r\n
Accept-Charset: iso-8859-1,*,utf-8\r\n
\r\n";

////Tabela ASCII (0-9 = 48-57) e (A-Z = 65-90) e (a-z = 97-122) 
//{Table ascii, source X, source Y,source Width, source Heigth}
//{ 0, 75, 5, 7}
struct char_dockapp
{
    int i,x,y,w,h;
};

struct char_dockapp chrdockapp[] =
{
  {45,130,75,5,7}, //-
  {48,0,82,5,7}, //0
  {49,5,82,5,7}, //1
  {50,10,82,5,7},//2
  {51,15,82,5,7},//3
  {52,20,82,5,7},//4
  {53,25,82,5,7},//5
  {54,30,82,5,7},//6
  {55,35,82,5,7},//7
  {56,40,82,5,7},//8
  {57,45,82,5,7},//9  
  {65,0,75,5,7}, //A e a
  {66,5,75,5,7}, //B e b
  {67,10,75,5,7}, //C e c
  {68,15,75,5,7}, //D e d
  {69,20,75,5,7}, //E e e
  {70,25,75,5,7}, //F e f
  {71,30,75,5,7}, //G e g
  {72,35,75,5,7}, //H e h
  {73,40,75,5,7}, //I e i
  {74,45,75,5,7}, //J e j
  {75,50,75,5,7}, //K e k
  {76,55,75,5,7}, //L e l
  {77,60,75,5,7}, //M e m
  {78,65,75,5,7}, //N e n
  {79,70,75,5,7}, //O e o
  {80,75,75,5,7}, //P e p
  {81,80,75,5,7}, //Q e q
  {82,85,75,5,7}, //R e r
  {83,90,75,5,7}, //S e s
  {84,95,75,5,7}, //T e t
  {85,100,75,5,7}, //U e u
  {86,105,75,5,7}, //V e v
  {87,110,75,5,7}, //W e w
  {88,115,75,5,7}, //X e x
  {89,120,75,5,7}, //Y e y
  {90,125,75,5,7}, //Z e z
  {95,135,75,5,7}, //_  
};



struct str_machine
{
	char host[64];
	char ip[64];
	char service[64];
	char porta[12];
	char email[128];
	char envsounds[32];
	char audio[256];
	char monitor[32];
}strmachine;

int readConfigfile(char param_conf[]);
int test_service(void);
int playerSound(char arqsom[]);
int goMail(void);
int writeTitle(void);

int Get(const char *hostip, int port, char *request, char *replybuf, int repbuflen);
int Get_SSL (char *ip, int port, char *http_request, char *replybuf, int replybuflen);


